Page MenuHomePhabricator

New Flow indentation model shows comments in the wrong order and level of indentation
Closed, ResolvedPublic

Description

From ptwiki:

@DannyH (WMF): The current behavior of Talk:UmaCoisa doesn't look good. See the second reply (A.2) to the main message of this topic:

...and if there are a few more replies ([1, [2), the new indentation makes it confusing to identify that both "A.1.1" and "A.1.2" are replies to the same comment "A.1", because in the new model they do not have the same level of indentation. Also, I see no reason why "A.1.2" should be more indented than "A.1.1.1". This breaks the expectations we have from en:Wikipedia:Indentation:

  1. If you want to reply to a comment, but another editor has already done so, just position your own text beneath that other editor's reply, at the same indentation level

(...)

  1. Your response to a reply should be positioned below that reply, but above any later responses that were made to a different comment.

See also T93024: Flow pages should allow users to choose between view modes: classic indentation (by topic/replies), "Flow style" indentation and chronological (by timestamp).

Event Timeline

He7d3r created this task.Mar 25 2015, 2:10 PM
He7d3r raised the priority of this task from to Needs Triage.
He7d3r updated the task description. (Show Details)
He7d3r added a project: StructuredDiscussions.
He7d3r added subscribers: He7d3r, DannyH.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 25 2015, 2:10 PM

I think this is a feature, not a bug. But we will talk about it at the team triage.

Yes, this is the expected behavior for the new model that we're trying out.

The core idea is that you should be able to follow the general flow of conversation down the left side of the thread, and most simple conversations between two or three people will look flat. The indentation is a special feature that happens when somebody goes back in the chronology and creates a tangent based on an earlier post, instead of following the conversational flow.

That means that it's easy to scan through a large, complicated discussion and immediately see where the disagreements and clarifications are happening. The indentations actually have a meaning -- they highlight the complicated parts of the discussion -- rather than just being an artifact of the normal flow of conversation.

I know that you don't like the new model, and Brad doesn't either, based on how it looks when you do "3. B responds to A" tests. In other tests, when we had actual group conversations, the new model seemed a lot clearer, and people liked it better.

The model that we've been using for the last year just isn't working -- I don't think anybody likes it, or understands it. I think we ought to try changing it, and it's worth giving the new model a shot.

We're going to release the new model later today, and we want to see how it works in the real world for a couple weeks. This is still an ongoing exploration, and not a final decision. This may turn out to be a terrible, confusing idea, and if we see that, then we'll keep working on it and thinking about it. Is that okay?

He7d3r added a comment.EditedMar 25 2015, 9:04 PM

I'm not basing the reports on

how it looks when you do "3. B responds to A" tests"

I'm using these texts just to describe how you can reproduce a test I did (because Flow changes the position/order of the comments). For an example without such texts, this makes no sense at all:
http://flow-tests.wmflabs.org/wiki/Topic:Se7z7lomivlor1og
How is agreeing with other users tangent to the topic?
If Someone replied before SomeoneElse, why would Flow make SomeoneElse's comment look out of context (given that it says he is agreeing with what was said before his comment, while the only other comment is now displayed after it).

where the disagreements and clarifications are happening. The indentations actually have a meaning -- they highlight the complicated parts of the discussion -- rather than just being an artifact of the normal flow of conversation.

That is not the current meaning of indentation in discussions (it is documented at en:Wikipedia:Indentation). Using it for a new meaning in Flow just makes it less understandable than wikitext discussions (and old discussions are not going to be converted to flow, are they? So we would have an inconsistent use of indentation, forever).

I don't think that example makes sense.

  • Unicorn says "Do you think we should merge Banana to Fruits?"
  • Someone says "I don't think so. Banana deserves its own article."

Then you have SomeoneElse making a comment that doesn't make sense. If SomeoneElse is agreeing with Unicorn, then SE's message would be, "Yes, I think we should merge the pages", and the indentation would be appropriate there.

It is true that when you go back in the chronology and reply directly to a past comment, the chronology on the page can get difficult to follow. Doing it in wikitext is just as confusing. You can't allow people to insert comments outside of the chronology and then try to read them chronologically. If it's important to follow the discussion chronologically, then you should post after the last comment and keep the conversation going.

The new indentation model does actually follow the en:Wikipedia:Indentation rules more closely than the old one did. The new model violates step 1, but then it follows steps 2, 3 and 4 exactly. The old model followed step 1, but violated 2, 3 and 4.

Oh, I see. Why wouldn't you add the third comment under the other two?

@DannyH: Just to be sure I'm understanding what you are asking, which string should be under which other two strings?

In the first link you posted:

  • Wgolf posts "An album that probably should be redirected to the band, see also: etc"
  • Karlhard says "Fails WP:NALBUMS."

Then the third person (New Age Retro Hippie) wants to post that he agrees with Wgolf, as per Karlhard.

In that situation, the obvious thing to do is to post that message under Karlhard's, which is what he did. On Flow, that would create a conversation with three posts, the same way that it is in wikitext. The only difference is that all three posts would be aligned on the left side, which isn't a meaningful difference.

You're suggesting that New Age Retro Hippie should post his message under Wgolf's. That wouldn't make sense in either wikitext or Flow.

Not really... I'm saying that when New Age Retro Hippie posts his reply to Wgolf, Flow puts it above Karlhard's reply, instead of below it.

Only if he clicks on the wrong button. The sensible button that he should click on -- which I think people in that situation will naturally click on -- is the reply link or input field at the bottom of the thread.

If he clicks on the wrong button (the "Reply" link under Wgolf's post), then the entry field will open in the same place where his message will be posted. If that isn't where he intends to post his message, then that's a clear signal that he should try the other link.

I might be 100% percent wrong about this -- we've done a lot of tests, but as you can see, trying to predict what people will do in real conversations is complicated. But I want to see where New Age Retro Hippie actually posts his reply in this case. If I'm wrong, then we'll be able to see it and figure it out.

He7d3r added a comment.EditedMar 25 2015, 11:13 PM

As far as I can see, semantically, the reply button under Wgolf's post is the right button to reply to Wgolf's post. I don't see why Flow should incentive people to click in a wrong button (the reply button related to someone else's post), when replying to Wgolf's proposal (and if they do this, then Flow will probably store the wrong relationship between comments, making it impossible for someone to implement e.g. a gadget to make the indentation unlimited, reflecting the exact hierarchy between comments and replies - as in LQT).

Helder: You and I are not going to agree on this right now. I don't know what we can do about it, except to agree to disagree for the moment, and see how the new model works when people are having real conversations. Then we can come back, maybe in just a few days, and we'll talk about what we've observed.

Is it okay to do that?

Okay, thanks. It's live now on Mediawiki, if you want to try it out.

Previous conversations might be a little wonky, because we didn't change how they're displayed. So the rules might seem a little weird. Conversations that start now will be using the new system as it is intended.

Let's keep letting people use the new model in production as is, for now. Part of it is just a normal learning curve.

However, if people have problems, one thing I'd like us to look at again is the Reply/Comment distinction.

FWIW, I fail to see how the "new model" (sic) follows WP:INDENT.
It just seems to be putting together the worst of the flat and threaded models.

The change was just released yesterday on Mediawiki, and we're going to look very closely at the conversations that people have on the Flow boards there.

The thing that's most important for us to look for are people who aren't able to communicate with each other, because the system either confuses them, or the conversation that they're having doesn't make sense when you read it. It might be a little tough to see at the very beginning, because there may be some people who are just testing and kicking the tires a bit. But that's what we'll be looking for -- can people have high-quality, high-signal-to-noise conversations using Flow?

If the answer is no -- and it could be, that happens to me all the time -- then we can see what's happening, and figure out what to change.

DannyH changed the task status from Open to Stalled.Mar 27 2015, 5:41 PM

I'm marking this as Stalled for right now, but we'll be looking and talking about this more in the coming weeks. Thanks for your patience as we work on this.

DannyH triaged this task as Normal priority.Mar 27 2015, 5:42 PM

This is completely out of place... It is a reply to @Quiddity's comment "Winter is not ever intended to be released as a Complete Skin, or a Beta Feature", not to JKDw's as Flow made it look like.

That's because it's a mix of the old threading (3 month old topic) and the new software configuration. The old/existing content was not re-arranged to account for the update to this new indentation model. Hence, only fresh topics will be consistent with it. Sorry for the confusion.

Ok. I guess I'll have to keep adding permanent links to the comments I'm replying to, so that users can know what I mean even if flow doesn't help them to do so...

Restricted Application added a project: Collaboration-Team-Triage. · View Herald TranscriptApr 3 2015, 12:13 AM
Jay8g added a subscriber: Jay8g.May 6 2015, 12:30 AM
He7d3r changed the task status from Stalled to Open.May 10 2015, 3:58 PM

This has been broken for almost two months now.

Helder, can you show an example of a thread where it's hard to follow the conversation because of the new indentation model?

There is some inconsistent UI for conversations that began before the indentation change and then continued after it. That's a pain, but we can't go back and spot-fix individual conversations.

But I'd like to see a conversation where you can't tell who's talking to who. I've seen some examples that are about the indentation itself -- people posting "A. reply to B." messages -- but I haven't seen any actual conversations yet where the flow of conversation is unclear.

Helder, can you show an example of a thread where it's hard to follow the conversation because of the new indentation model?

The ease in following a conversation is arguably a matter of taste.
As such, I believe there's no point in making one taste prevail over the other.
Flow shall support a per-user preference to set the indentation model anyone is more comfortable with.

Oh, good, thanks for the examples.

It seems like there's a concept that isn't being communicated to you through the software, and I want to figure out where we're failing to provide the right cues.

The concept is that the structure of a basic online conversation between multiple people over time is a group conversation. You're speaking to the entire group, and responding to everything that's been said so far. In a chronological conversation, everything is aligned to the left side, and it just goes down the page. Post #20 isn't a direct response to post #1; it's a response to #1-19.

As an example, that's how Phabricator is treating this conversation. There are six people talking in this thread, and every post is aligned to the left, but it's not confusing.

You and Ricordisamoa both replied to my last message. I understood that what you said was a response to my question -- I wasn't confused about why you were giving examples to Ricordisamoa. In this case, the structure is particularly clear because I asked a question, and you posted an answer to my question. But I think this would be clear even if there wasn't such an obvious question/answer interaction.

I'm going to respond to each of your five examples below.

The last three links in your list are three consecutive posts from the same conversation, "Página IDCP". With the exception of Teles, who responded out of chronology to specifically address Leonardo's post, the conversation continues down the left side of the page in the same way that this Phabricator conversation does. I'm using Google Translate to help me read the Portuguese, but it looks like a productive conversation that everyone involved understands and is able to participate in. The conversation doesn't grind to a halt at any point -- Victor, Lucas and the IP keep talking until they reach a natural end point. The moments where somebody is thanking someone -- and therefore it's important to specify who they're thanking -- they use the person's name, as in: "Obrigado, Leonardo," and "Victor, obrigado pela elucidação."

So I don't see a reason why that conversation would be improved if all the posts were arranged diagonally.

For the other examples --

On link #2 ("Como faço pra remover meu e-mail?"), that's another conversation proceeding chronologically, and as far as I can tell, easy for everybody to understand and participate in. It's clear that your response is another answer to Zoldyick's question, because you're answering the question.

Zoldyick's response is more to Teles' post than yours, so it begins, "Teles já sim." He could have used the reply link under Teles' post, but instead he used the reply field at the bottom, because that's the standard way to continue the conversation. If Teles' reply and your reply were both indented equally under Zoldyick's first post, then he would probably still have used the entry field under your post but using Teles' name. Again, I don't see why this conversation would be better if it were diagonal, and if everybody had to choose the correct reply link before posting their response.

Now, the first link that you posted -- "Por que mudaram a estrelinha de destaque?" -- is a bit of a puzzle. It began with Zoldyick posting two messages, one after the other, and then WikiFer clicked on the reply link under Zoldyick's first response, instead of the second. I'm not sure why. That also happens at the bottom of the conversation -- LuizM says, "Já que não obtivemos consenso, vamos abrir uma discussão na Esplanada?" and then posts immediately afterwards, saying, "Criei." Then Zoldyick clicked on the reply link for the first of LuizM's two messages, instead of the second. So this conversation does get a bit confusing, because people are making a distinction between two consecutive messages by the same person. That's the one that feels to me like a problem to figure out.

I've been wondering about the text in the entry field, which is different based on which reply link you're clicking on. If the bottom entry field always says "Reply to (topic name)" and the internal reply links say "Reply to (text snippet)," then that might be giving the wrong cues. If they all say something like "Reply to this discussion," then it might encourage the behavior in example #2-5, and discourage what happened in example #1. What do you think?

He7d3r set Security to None.May 13 2015, 1:12 AM
He7d3r removed a subscriber: He7d3r.
DannyH closed this task as Resolved.May 27 2015, 8:19 PM
DannyH claimed this task.

@DannyH: have you restored the 'classic' indentation model? I haven't checked.

The indentation model is working as intended. This was a feature request, not a bug. The "classic" model got more criticism than the new version, so I don't think going back to it would be an improvement.

He7d3r awarded a token.Jun 3 2015, 5:21 PM

@He7d3r

"This comment from LuizM was posted before the comment from Zoldyick, but it appears after it, and with a different indentation." - 1) luizm could not post his second comment in the subthread place, like zoldyick posted, because at that time, he posted to the latest post of the thread. 2) then, zoldyick answers to first post of him, but he could answer to both posts of him - if he posted to the end of thread.

"I'm talking to Zoldyick, not to Teles, here:" - you had choice, to click under teles's post, or under zoldyick's post, you clicked under Teles's. green color shows the linked comment:

"This was a reply to Leonardo, not to the IP itself:" - he could not select another place to reply, because, he replied to latest post in thread, and only then leonardo's post stoppped to be latest post, and started to allow to create subthread for itself.

"This was a reply to Leonardo, not to 187.37.144.169:" - but he intentionally replied to main thread, because he could select 2 places to reply - leonardo's comment, and end of main thread.

"This was a reply to 187.37.144.169, not to Rosário:" - but he intentionally replied to main thread, because he could select 2 places to reply - 187.37.144.169's comment, and end of main thread.

DannyH removed DannyH as the assignee of this task.Feb 8 2016, 7:20 PM
DannyH removed a subscriber: DannyH.